<?php
/**
* Accordian FrontPage Core - Joomla Module
* Version			: 3.0
* Created by		: RBO Team::RumahBelanja.com - AppsNity Project::AppsNity.Com
* Created on		: December 2008 (Joomla 1.5.x) - December 2010 (Joomla 1.6.x) - December 2011 (Joomla 1.7.x)
* Updated on		: Oct 1st, 2014 (Only for Joomla 3.x.x)
* Package			: Joomla 3.x.x
* License			: http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/
defined('_JEXEC') or die;

require_once JPATH_SITE . '/components/com_content/helpers/route.php';

JModelLegacy::addIncludePath(JPATH_SITE . '/components/com_content/models', 'ContentModel');


abstract class modAccordianFpCoreHelper
{	
	function corearticlessystem( $text, $length=200 ) {
		//$strip = strip_tags($text);
		//$endText = (strlen($strip) > 200) ? "..." : ""; 
		// strips tags won't remove the actual jscript
		$text = preg_replace( "'<script[^>]*>.*?</script>'si", "", $text );
		$text = preg_replace( '/{.+?}/', '', $text);
		// replace line breaking tags with whitespace
		$text = preg_replace( "'<(br[^/>]*?/|hr[^/>]*?/|/(div|h[1-6]|li|p|td))>'si", ' ', $text );
		$text = substr(strip_tags( $text ), 0, $length) ;
		
		return $text;
		
	}	
	
	public static function getList(&$params)
	{
		$app = JFactory::getApplication();

		//Get the config
		$config = JFactory::getConfig();
		$toffset = $config->get('config.offset');
		
		// Get an instance of the generic articles model
		$model = JModelLegacy::getInstance('Articles', 'ContentModel', array('ignore_request' => true));

		// Set application parameters in model
		$appParams = JFactory::getApplication()->getParams();
		$model->setState('params', $appParams);
		
		//Get Parameters in module params
		$time_format= $params->get( 'time_format', 'D, d-m-Y H:i' );
		$text_length = intval($params->get( 'preview_count', 200) );
		
		// Set the filters based on the module params
		$model->setState('list.start', (int) $params->get('totalskip', 0));
		$model->setState('list.limit', (int) $params->get('count', 5));

		$model->setState('filter.published', 1);

		$model->setState('list.select', 'a.fulltext, a.id, a.title, a.alias, a.introtext, a.state, a.catid, a.created, a.created_by, a.created_by_alias,' .
			' a.modified, a.modified_by, a.publish_up, a.publish_down, a.images, a.urls, a.attribs, a.metadata, a.metakey, a.metadesc, a.access,' .
			' a.hits, a.featured' );

		// Access filter
		$access     = !JComponentHelper::getParams('com_content')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$model->setState('filter.access', $access);

		// Category filter
		$model->setState('filter.category_id', $params->get('catid', array()));

		// User filter
		$userId = JFactory::getUser()->get('id');

		switch ($params->get('user_id'))
		{
			case 'by_me':
				$model->setState('filter.author_id', (int) $userId);
				break;
			case 'not_me':
				$model->setState('filter.author_id', $userId);
				$model->setState('filter.author_id.include', false);
				break;

			case '0':
				break;

			default:
				$model->setState('filter.author_id', (int) $params->get('user_id'));
				break;
		}
		
		//Filter by Date
		$date_filtering = $params->get('date_filtering', 'off');
		if ($date_filtering !== 'off') {
			$model->setState('filter.date_filtering', $date_filtering);
			$model->setState('filter.start_date_range', $params->get('start_date_range', '1000-01-01 00:00:00'));
			$model->setState('filter.end_date_range', $params->get('end_date_range', '9999-12-31 23:59:59'));
			$model->setState('filter.relative_date', $params->get('relative_date', 500));
		}
		
		// Filter by language
		$model->setState('filter.language', $app->getLanguageFilter());

		//  Featured switch
		switch ($params->get('show_featured'))
		{
			case '1':
				$model->setState('filter.featured', 'only');
				break;
			case '0':
				$model->setState('filter.featured', 'hide');
				break;
			default:
				$model->setState('filter.featured', 'show');
				break;
		}
		// Set ordering
		$ordering = $params->get('ordering', 'a.publish_up');
		$model->setState('list.ordering', $ordering);

		if (trim($ordering) == 'rand()')
		{
			$model->setState('list.direction', '');
		}
		else
		{
			$direction = $params->get('direction', 1) ? 'DESC' : 'ASC';
			$model->setState('list.direction', $direction);
		}

		// Retrieve Content
		$items = $model->getItems();

		foreach ($items as &$item)
		{
			$item->readmore = strlen(trim($item->fulltext));
			$item->slug     = $item->id . ':' . $item->alias;
			$item->catslug  = $item->catid . ':' . $item->category_alias;

			if ($access || in_array($item->access, $authorised))
			{
				// We know that user has the privilege to view the article
				$item->link     = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catid));
				$item->linkText = JText::_('AFC_READMORE');
			}
			else
			{
				$item->link     = JRoute::_('index.php?option=com_users&view=login');
				$item->linkText = JText::_('AFC_READMORE_REGISTER');
			}

			$item->introtext = JHtml::_('content.prepare', $item->introtext);
			$item->name = htmlspecialchars( $item->author );
			$item->created=JHTML::_('date', htmlspecialchars( $item->created ),"$time_format", $toffset);
			// New
			if (!$params->get('image'))
			{
				$item->introtext = preg_replace('/<img[^>]*>/', '', $item->introtext);
			}
			
			$item->introtext = JHtml::_('string.truncate', $item->introtext, $params->get('limit_word',400));
			
			$results                 = $app->triggerEvent('onContentAfterDisplay', array('com_content.article', &$item, &$params, 1));
			$item->afterDisplayTitle = trim(implode("\n", $results));

			$results                    = $app->triggerEvent('onContentBeforeDisplay', array('com_content.article', &$item, &$params, 1));
			$item->beforeDisplayContent = trim(implode("\n", $results));
		}

		return $items;
	}
}