<?php
/**
* Accordian FrontPage Core - Joomla Module
* Version			: 1.2
* Created by		: RBO Team - RumahBelanja.com
* Created on		: December 2008 (Joomla 1.5.x) and December 2010 (Joomla 1.6.x)
* Updated on		: December 18th, 2010
* Package			: Joomla 1.5.x
* License			: http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');
jimport('joomla.utilities.date');

class modAccordianFpCoreHelper
{
	function corearticlessystem( $text, $length=200 ) {
		//$strip = strip_tags($text);
		//$endText = (strlen($strip) > 200) ? "..." : ""; 
		// strips tags won't remove the actual jscript
		$text = preg_replace( "'<script[^>]*>.*?</script>'si", "", $text );
		$text = preg_replace( '/{.+?}/', '', $text);
		// replace line breaking tags with whitespace
		$text = preg_replace( "'<(br[^/>]*?/|hr[^/>]*?/|/(div|h[1-6]|li|p|td))>'si", ' ', $text );
		$text = substr(strip_tags( $text ), 0, $length) ;
		
		return $text;
		
	}	
	
	function getList(&$params)
	{
		global $mainframe;

		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$config 	=& JFactory::getConfig();
		$tzoffset	= intval($config->getValue('config.offset'));
		$userId		= (int) $user->get('id');

		$count		= (int) $params->get('count', 5);
		$catid		= trim( $params->get('catid') );
		$secid		= trim( $params->get('secid') );
		$time_format= $params->get( 'time_format', '%a, %d-%b-%Y' );
		$totalskip	= (int) $params->get( 'totalskip', 0);
		$show_front	= $params->get('show_front', 1);
		$aid		= $user->get('aid', 0);

		$text_length = intval($params->get( 'preview_count', 200) );

		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access		= !$contentConfig->get('shownoauth');

		$nullDate	= $db->getNullDate();
		$now		= date('Y-m-d H:i:s', time());

		$where		= 'a.state = 1'
			. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
			. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
			;

		// User Filter
		switch ($params->get( 'user_id' ))
		{
			case 'by_me':
				$where .= ' AND (created_by = ' . (int) $userId . ' OR modified_by = ' . (int) $userId . ')';
				break;
			case 'not_me':
				$where .= ' AND (created_by <> ' . (int) $userId . ' AND modified_by <> ' . (int) $userId . ')';
				break;
		}

		// News Ordering
		switch ($params->get( 'orderedby' )) {
			case 1:
				$ordering = "a.created DESC";
			break;
			case 2:
				$ordering = "a.created ASC";
			break;
			case 3:
				$ordering  = "a.hits DESC";
			break;
			case 4:
				$ordering  = "a.hits ASC";
			break;
			case 5:
				$ordering  = "a.modified DESC, a.created DESC";
			break;
			case 0:
			default:
				$ordering  = "RAND()";
			break;
			}

		if ($catid)
		{
			$ids = explode( ',', $catid );
			JArrayHelper::toInteger( $ids );
			$catCondition = ' AND (cc.id=' . implode( ' OR cc.id=', $ids ) . ')';
		}
		if ($secid)
		{
			$ids = explode( ',', $secid );
			JArrayHelper::toInteger( $ids );
			$secCondition = ' AND (s.id=' . implode( ' OR s.id=', $ids ) . ')';
		}

		// Content Items only
		$query = 'SELECT a.*, u.id, u.name,' .
			' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
			' FROM #__content AS a' .
			($show_front == '0' ? ' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id' : '') .
			' LEFT JOIN #__users AS u ON u.id = a.created_by' .
			' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
			' INNER JOIN #__sections AS s ON s.id = a.sectionid' .
			' WHERE '. $where .' AND s.id > 0' .
			($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid : '').
			($catid ? $catCondition : '').
			($secid ? $secCondition : '')
			. "\n AND ((TO_DAYS('" . date( 'Y-m-d', time()+$tzoffset*60*60 ) . "') ) )"
			.($show_front == '0' ? ' AND f.content_id IS NULL ' : '').
			' AND s.published = 1' .
			' AND cc.published = 1' .
			' ORDER BY '. $ordering;
		$db->setQuery($query, $totalskip, $count);
		$rows = $db->loadObjectList();

		$i		= 0;
		$lists	= array();
		foreach ( $rows as $row )
		{
			$lists[$i]->created_by = htmlspecialchars( $row->created_by );
			$lists[$i]->created_by_alias = htmlspecialchars( $row->created_by_alias );
			$lists[$i]->link = ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid);
			$lists[$i]->title = htmlspecialchars( $row->title );
			$lists[$i]->introtext = modAccordianFpCoreHelper::corearticlessystem( $row->introtext, $text_length);
			$lists[$i]->created=JHTML::_('date', htmlspecialchars( $row->modified ),"$time_format", $tzoffset);
			$lists[$i]->name = htmlspecialchars( $row->name );
			$i++;
		}

		return $lists;
	}



}
